#!/usr/bin/perl

################################################################################
#     Beomdori's Web Link v0.9
#
#     Programmer : BeomGyu, Lee
#     E-Mail     : cadeau@orgio.net
#     Homepage   : http://beomdori.x-y.net
#
################################################################################

#################################[ȯ漳]######################################
$gBaseDIR = "./";                 
$gCGI_URL = "./bdr_link.cgi";      #  cgi URL
$gIconURL = "./img";               # ̹ URL
$gMakeBoard = "Y";                 # db 鶧 Y,  ̻ ȸ鶧 N 
#################################################################################

$gLockFlag = "N";
$gLockStat = "N";

umask(000);
&parseArgument;
sub parseArgument {
    local($buffer,$data,$name,$value);
    local(@datum);

    if($ENV{'REQUEST_METHOD'} eq "GET") {
        $buffer = $ENV{'QUERY_STRING'};
    }
    else {
        read(STDIN,$buffer,$ENV{'CONTENT_LENGTH'});
    }

    @datum = split(/&/,$buffer);
    foreach $data (@datum) {
        ($name,$value) = split(/=/,$data);
        $value =~ tr/+/ /;
        $value =~ s/%([a-fA-F0-9]{2})/pack("C",hex($1))/eg;

        $FORM{$name} = $value;
    }
    if($FORM{'id'}) {
        $gBaseDIR = "$gBaseDIR/$FORM{'id'}";
        $gNumFile = "$FORM{'id'}.num";
        $gCfgFile = "$FORM{'id'}.cfg";
        $gPwdFile = "$FORM{'id'}.pwd";
        $gDatFile = "$FORM{'id'}.idx";
    }
    else {
        &HTMLHeader;
        print "<font color=$gTextColor>ũϴ </font>\n";
        print "<br><br><hr noshade width=80%>\n";
        print "<font color=red>$gCGI_URL?id=<font color=$gTextColor>ھ̵</font></font><br>\n";
        print "<hr noshade width=80%><p>\n";
        &HTMLFooter;
    }
    if(open(HANDLE,"<$gBaseDIR/$gNumFile")) {
        close(HANDLE);
        &selectAction;
    }
    else {
        if($gMakeBoard eq "Y") {
            &selectAction;
        }
        else {
            &HTMLHeader;
            print "<br><br><hr noshade width=80%>\n";
            print "<font color=red>ڿ  Ⱑ Ǿϴ</font><br>\n";
            print "<hr noshade width=80%><p>\n";
            &HTMLFooter;
        }
    }
}

sub selectAction {
    &getNumber;
    &getEnvVar;

    unless($FORM{'action'}) {
        $FORM{'action'} = "r";
    }

    if($FORM{'action'} eq "r") {	
	&readData;
    } 
    elsif($FORM{'action'} eq "show_input_form") {
       &checkAdminPassword;
	&showInputForm;
    }
    elsif($FORM{'action'} eq "show_user_input_form") {
      if($gUserUp eq "YES") {
        &showUserInputForm;
      }
    }
    elsif($FORM{'action'} eq "write") {
	&writeData;
    } 
    elsif($FORM{'action'} eq "delete") {
        &checkUserPassword;
	&deleteData;
    } 
    elsif($FORM{'action'} eq "show_update_form") {
        &checkUserPassword;
	&showUpdateForm;
    } 
    elsif($FORM{'action'} eq "update") {
	&updateData;
    } 
    elsif($FORM{'action'} eq "users_login") {
        &showUsersLogin;
    }
    elsif($FORM{'action'} eq "admin_login") {
        &showAdminLogin;
    }
    elsif($FORM{'action'} eq "show_config_form") {
       &checkAdminPassword;
       &showConfigForm;
	}
    elsif($FORM{'action'} eq "config") {
        &updateEnvVar;
    }
    elsif($FORM{'action'} eq "search") {
	&searchData;
    }

    else {
        exit;
    }
}

sub getNumber {
    if(open(HANDLE,"<$gBaseDIR/$gNumFile")) {
        $gNoOfData = <HANDLE>;
        close(HANDLE);
        chop($gNoOfData);

        open(HANDLE,"<$gBaseDIR/$gDatFile");
            @datum = <HANDLE>;
        close(HANDLE);
        if($gNoOfData != $#datum) {
            $gNoOfData = $#datum;
            &putNumber;
        }
    }
    else {
        mkdir("$gBaseDIR",0777);  
        mkdir("$gBaseDIR/messages",0777);

        open(HANDLE,">$gBaseDIR/$gDatFile");
            print HANDLE "<!--EOF-->\n";
        close(HANDLE);

        $gNoOfData = "0";
        &putNumber;
    } 
}

sub putNumber {
    open(HANDLE,">$gBaseDIR/$gNumFile");
        print HANDLE "$gNoOfData\n";
    close(HANDLE);
}

sub getEnvVar {
    local($env_list);
    local(@datum);

    if(open(HANDLE,"<$gBaseDIR/$gCfgFile")) {
        $env_list = <HANDLE>;
        close(HANDLE);
        @datum = split(/\|/,$env_list);

        $gBackColor = $datum[1];
        $gBackImgURL = $datum[2];
        $gTitleText = $datum[3];

        $gRecPerPage = $datum[6];
        $gListNumber = $datum[7];

        $gTitleUse = $datum[11];

        $gTableWidth = $datum[5];
        $gTableTapText = $datum[13];
        $gTableTapBgcolor = $datum[27];        
        $gTableBgcolor = $datum[21];
        $gTableText = $datum[15];
        $gActiveTableColor = $datum[14];
        $gTableintervalColor = $datum[10];        
        
        $gFastFind = $datum[28];
        $gFastFind1 = $datum[29];
        $gFastFind2 = $datum[30];
        $gFastFind3 = $datum[31];
        $gFastFind4 = $datum[32];
        $gFastFind5 = $datum[33];

        $gUserUp = $datum[34];
        $gTextColor = $datum[17];

        $gTempNum1 = $datum[20];   # 0 or 1        
        $gTempNum2 = $datum[12];
        $gTempURL1 = $datum[26];        
        $gTempURL2 = $datum[4];        
        $gTempColor1 = $datum[8];
        $gTempColor2 = $datum[9];
        $gTempColor3 = $datum[18];        
	$gTempColor4 = $datum[16];
        $gTempColor5 = $datum[22];
        $gTempColor6 = $datum[23];
        $gTempYesOrNo1 = $datum[19];        
        $gTempYesOrNo2 = $datum[24];
        $gTempYesOrNo3 = $datum[25];
        $gTempYesOrNo4 = $datum[36];        
        $gTempYesOrNo5 = $datum[35];                

        chop($gHomeImageURL);
    }
    else {
        # ʱ ȯ 

        $gBackColor = "#ffffff";
        $gBackImgURL = "./img/bg.gif";
        
        $gTitleText = " Web Link ";
        $gTitleUse = "YES";

        $gTableWidth = "90%";         
        $gTableTapText = "#ffffff";        
        $gTableTapBgcolor = "#494949";
        $gTableBgcolor = "#ffffff";
        $gTableText = "#000000";
        $gActiveTableColor = "#f5f5f5";
        $gTextColor = "#000000";

        $gRecPerPage = 10;
        $gListNumber = "5";
                
        $gFastFind = "0";
        $gFastFind1 = "";
        $gFastFind2 = "";
        $gFastFind3 = "";
        $gFastFind4 = "";
        $gFastFind5 = "";

        $gUserUp = "NO";

        $gTempNum1 = "1";
        $gTempNum2 = "1";        
        $gTempColor1 = "#000000";
        $gTempColor2 = "#000000";        
        $gTempColor3 = "#000000";        
	$gTempColor4 = "#000000";        
        $gTempColor5 = "#000000";
        $gTempColor6 = "#000000";
        $gTableintervalColor = "#000000";                
        $gTempYesOrNo1 = "YES";
        $gTempYesOrNo2 = "YES";
        $gTempYesOrNo3 = "YES";
        $gTempYesOrNo4 = "YES";
        $gTempYesOrNo5 = "YES";        
        $gTempURL1 = "";
        $gTempURL2 = "";
        
        &putEnvVar;
    }
}
 
sub putEnvVar {
    open(HANDLE,">$gBaseDIR/$gCfgFile");
        print HANDLE "^^|$gBackColor|$gBackImgURL|$gTitleText|$gTempURL2|$gTableWidth|$gRecPerPage|$gListNumber|$gTempColor1|$gTempColor2|$gTableintervalColor|$gTitleUse|$gTempNum2|$gTableTapText|$gActiveTableColor|$gTableText|$gTempColor4|$gTextColor|$gTempColor3|$gTempYesOrNo1|$gTempNum1|$gTableBgcolor|$gTempcolor1|$gTempcolor2|$gTempYesOrNo2|$gTempYesOrNo3|$gTempURL1|$gTableTapBgcolor|$gFastFind|$gFastFind1|$gFastFind2|$gFastFind3|$gFastFind4|$gFastFind5|$gUserUp|$gTempYesOrNo5|$gTempYesOrNo4|\n";
    close(HANDLE);
}

sub readData {
    if($FORM{'p'}) {
        $gCurPage = $FORM{'p'};
    }
    else {
        $gCurPage = "1";
    }

    $gTotPage = int(($gNoOfData-1)/$gRecPerPage)+1;

    &HTMLHeader;

    print "<table border=0 width=$gTableWidth cellpadding=0 cellspacing=1 align=center valign=top>\n";
    print "<tr><td width=220 align=left valign=top>";
     
    &MenuButton;
    
    print "</td>\n\n";


    print "<td width=50>&nbsp;</td><td><br><br>\n\n";

    &readIndexFile;

    print "</td></tr></table></td></tr><tr><td colspan=3>\n";

    &FastGo;

    print "</td></tr></table>\n";
    &HTMLFooter;
}

sub readIndexFile {
    local($i,$j,$rec_color,$txt_color,$actual_number,$short_subject,$short_date,$old_date,$new_date);
    local(@datum,@value);

    open(HANDLE,"$gBaseDIR/$gDatFile");
        @datum = <HANDLE>;
    close(HANDLE);

for($i=($gCurPage-1)*$gRecPerPage+1;$i<=($gCurPage-1)*$gRecPerPage+$gRecPerPage;$i++) {
        @value = split(/\|/,$datum[$i]);    
        $actual_number = ($gNoOfData+1)-$i;

        if($actual_number > 0) {
$date_length = length($value[5]);

$short_date = substr($value[5],0,20);

print "<table border=0 width=100% cellspacing=1 cellpadding=0>\n";
$c=$gTableBgcolor;
$t=$gTableText;
$tc=$gTableTapText;
$dc=$gTableTapBgcolor;
print "<tr><td>\n<table border=0 width=100% cellspacing=0 cellpadding=3>\n";
print "<tr bgcolor=$dc><td>&nbsp;::&nbsp;<b><a href=\"$value[8]\" target=_blank><font color=$tc>$value[2]</font></a></b></td>\n";
print "<td align=right><a href=$gCGI_URL?id=$FORM{'id'}&action=users_login&p=$FORM{'p'}&c=show_update_form&l=$value[1]><img src=$gIconURL/modify.gif border=0 alt=\"Modify\"></a><a href=$gCGI_URL?id=$FORM{'id'}&action=users_login&p=$FORM{'p'}&c=delete&l=$value[1]><img src=$gIconURL/del.gif border=0 alt=\"Delete\"></a>";
print "</td></tr>\n";
print "</table><table border=0 width=100% cellspacing=0 cellpadding=3>\n";

# ȭ  (̹ ũǾֳ  ...)
if ($value[9] eq "") {
print "<tr bgcolor=$c onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\"><td colspan=2 height=150 align=left valign=top><font color=$t>$value[7]</font><br></td></tr>\n";
}
else {
print "<tr bgcolor=$c onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
# 
print "<td width=100% align=left valign=top><font color=$t>$value[7]</font><br></td>\n";
# ʿ ̹
print "<td width=200 height=150 align=right valign=top><a href=\"$value[8]\" target=_blank><img src=\"$value[9]\" border=0></a></td></tr>\n";
}
print "<tr><td colspan=2 width=100% height=1 bgcolor=\"$gTableintervalColor\"></td></tr>\n";
print "<tr><td colspan=2 width=100% height=2 bgcolor=\"$c\"></td></tr>\n";
print "<tr><td colspan=2 width=100% height=1 bgcolor=\"$gTableintervalColor\"></td></tr>\n";
print "<tr><td colspan=2>&nbsp;</td></tr>\n";
print "</table>\n</td></tr>\n\n";
}
}
    unless($gNoOfData) {
        print "&nbsp;<table width=100% border=0 cellspacing=1 cellpadding=6 align=center>\n";
        print "<tr align=center><td><font color=\"red\"><b> ϵ Ʈ ϴ.</font></b></td></tr>\n";
    }
}

sub FastGo {
###########quick number powered by ######
print "<table border=0 cellpadding=9 cellspacing=1 align=center valign=middle height=100><tr><td align=center>\n";
$term = $gListNumber;$f = 1;$l = $term;while ($f <= $gTotPage) {
if (($f <= $gCurPage) && ($gCurPage <= $l))
{$prevp = $f - 1;

if ($prevp > 0) {
print "<a href=$gCGI_URL?id=$FORM{'id'}&action=r&p=$prevp><img src=$gIconURL/y_prev.gif border=0 alt=\" \"></a>..";
}
else {
print "<img src=$gIconURL/n_prev.gif border=0>..";
}
if ($l <= $gTotPage) {
	for ($page = $f; $page <= $l; $page++) {
	if ($page == $gCurPage) {
print "<font color=$gTableText>[<font color=blue><b>$page</b></font>]</font>";
	}
else {
print "<a href=$gCGI_URL?id=$FORM{'id'}&action=r&p=$page>[$page]</a>";
}}}
else {
for ($page = $f; $page <= $gTotPage; $page++) {
	if ($page == $gCurPage) {
print "<font color=$gTableText>[<font color=blue><b>$page</b></font>]</font>";
}
else {
print "<font color=$gTextColor><a href=$gCGI_URL?id=$FORM{'id'}&action=r&p=$page>[$page]</font></a>";
}}}
$nextp = $l + 1;
  	if ($nextp <= $gTotPage) {
print "..<a href=$gCGI_URL?id=$FORM{'id'}&action=r&p=$nextp><img src=$gIconURL/y_next.gif border=0 alt=\" \"></a>";
}
else {print "..<img src=$gIconURL/n_next.gif border=0>";
}    }$f = $f + $term;
$l = $l + $term;}
print "</td></tr></table>\n";
##########quick number######
}

sub MenuButton {
    local($prev_page,$next_page);
    print "<br><br><font style=\"cursor:n-resize\"><table width=220 border=0 cellspacing=1 cellpadding=2>\n";
    print "<tr>\n";
    print "<td align=left>\n";
    print "<table border=0 cellspacing=1 cellpadding=3 width=220 valign=top>\n";    
    print "<tr><td background=$gIconURL/tb_top.gif height=30 width=220>\n";    
    # ŸƲ ǥÿ
    if($gTitleUse eq "YES") {
         print "<center><b>$gTitleText</b></center>\n";
     print "\n";
    }    
    print "</td></tr>\n";
    
    if ($gFastFind eq "1") {    	
        print "<tr><td onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">&nbsp;&nbsp;<a href=$gCGI_URL?id=$FORM{'id'}&action=search&word=FastFind1>$gFastFind1</a></td></tr>\n";
        print "<tr><td width=80% height=1 bgcolor=#e3e3e3></td></tr>\n";             
    }

    if ($gFastFind eq "2") {
       print "<tr><td onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">&nbsp;&nbsp;<a href=$gCGI_URL?id=$FORM{'id'}&action=search&word=FastFind1>$gFastFind1</a></td></tr>\n";
       print "<tr><td width=80% height=1 bgcolor=#e3e3e3></td></tr>\n";
       print "<tr><td onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">&nbsp;&nbsp;<a href=$gCGI_URL?id=$FORM{'id'}&action=search&word=FastFind2>$gFastFind2</a></td></tr>\n";
       print "<tr><td width=80% height=1 bgcolor=#e3e3e3></td></tr>\n";       
    }

    if ($gFastFind eq "3") {
       print "<tr><td onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">&nbsp;&nbsp;<a href=$gCGI_URL?id=$FORM{'id'}&action=search&word=FastFind1>$gFastFind1</a></td></tr>\n";
       print "<tr><td width=100% height=1 bgcolor=#e3e3e3></td></tr>\n";
       print "<tr><td onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">&nbsp;&nbsp;<a href=$gCGI_URL?id=$FORM{'id'}&action=search&word=FastFind2>$gFastFind2</a></td></tr>\n";
       print "<tr><td width=100% height=1 bgcolor=#e3e3e3></td></tr>\n";
       print "<tr><td onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">&nbsp;&nbsp;<a href=$gCGI_URL?id=$FORM{'id'}&action=search&word=FastFind3>$gFastFind3</a></td></tr>\n";
       print "<tr><td width=100% height=1 bgcolor=#e3e3e3></td></tr>\n";
    }

    if ($gFastFind eq "4") {
       print "<tr><td onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">&nbsp;&nbsp;<a href=$gCGI_URL?id=$FORM{'id'}&action=search&word=FastFind1>$gFastFind1</a></td></tr>\n";
       print "<tr><td width=100% height=1 bgcolor=#e3e3e3></td></tr>\n";
       print "<tr><td onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">&nbsp;&nbsp;<a href=$gCGI_URL?id=$FORM{'id'}&action=search&word=FastFind2>$gFastFind2</a></td></tr>\n";
       print "<tr><td width=100% height=1 bgcolor=#e3e3e3></td></tr>\n";
       print "<tr><td onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">&nbsp;&nbsp;<a href=$gCGI_URL?id=$FORM{'id'}&action=search&word=FastFind3>$gFastFind3</a></td></tr>\n";
       print "<tr><td width=100% height=1 bgcolor=#e3e3e3></td></tr>\n";    	
       print "<tr><td onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">&nbsp;&nbsp;<a href=$gCGI_URL?id=$FORM{'id'}&action=search&word=FastFind4>$gFastFind4</a></td></tr>\n";
       print "<tr><td width=100% height=1 bgcolor=#e3e3e3></td></tr>\n";       
    }

    if ($gFastFind eq "5") {
       print "<tr><td onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">&nbsp;&nbsp;<a href=$gCGI_URL?id=$FORM{'id'}&action=search&word=FastFind1>$gFastFind1</a></td></tr>\n";
       print "<tr><td width=100% height=1 bgcolor=#e3e3e3></td></tr>\n";
       print "<tr><td onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">&nbsp;&nbsp;<a href=$gCGI_URL?id=$FORM{'id'}&action=search&word=FastFind2>$gFastFind2</a></td></tr>\n";
       print "<tr><td width=100% height=1 bgcolor=#e3e3e3></td></tr>\n";
       print "<tr><td onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">&nbsp;&nbsp;<a href=$gCGI_URL?id=$FORM{'id'}&action=search&word=FastFind3>$gFastFind3</a></td></tr>\n";
       print "<tr><td width=100% height=1 bgcolor=#e3e3e3></td></tr>\n";    	
       print "<tr><td onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">&nbsp;&nbsp;<a href=$gCGI_URL?id=$FORM{'id'}&action=search&word=FastFind4>$gFastFind4</a></td></tr>\n";
       print "<tr><td width=100% height=1 bgcolor=#e3e3e3></td></tr>\n";       
       print "<tr><td onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">&nbsp;&nbsp;<a href=$gCGI_URL?id=$FORM{'id'}&action=search&word=FastFind5>$gFastFind5</a></td></tr>\n";
       print "<tr><td width=100% height=1 bgcolor=#e3e3e3></td></tr>\n";       
    }
    
    #   or    , ü ,  
      if($gUserUp eq "YES") {
      	print "<tr><td background=$gIconURL/tb_bottom.gif height=30 width=220 align=center>\n";
        print "<a href=$gCGI_URL?id=$FORM{'id'}&action=show_user_input_form><img src=$gIconURL/write.gif border=0 alt=\"Register\"></a>\n";
        print "<a href=$gCGI_URL?id=$FORM{'id'}&action=r&p=$FORM{'p'}><img src=$gIconURL/total_list.gif border=0 alt=\"Total List\"></a>\n";
        print "&nbsp;<a href=$gCGI_URL?id=$FORM{'id'}&action=admin_login&p=$gCurPage&c=show_config_form><img src=$gIconURL/admin.gif border=0 alt=\"Administrator Only\"></a>\n";
        print "</td></tr>\n";
        print "</table></font>\n";
      }
      else {
      	print "<tr><td background=$gIconURL/tb_bottom.gif height=30 width=220 align=center>\n";
        print "<a href=$gCGI_URL?id=$FORM{'id'}&action=r&p=$FORM{'p'}><img src=$gIconURL/total_list.gif border=0 alt=\"Total List\"></a>\n";
        print "&nbsp;<a href=$gCGI_URL?id=$FORM{'id'}&action=admin_login&p=$gCurPage&c=show_config_form><img src=$gIconURL/admin.gif border=0 alt=\"Administrator Only\"></a>\n";
        print "</td></tr>\n";
        print "</table></font>\n";
      }
          
    print "</td></tr></table></font>\n";
}

sub searchData {
    local($data,$counter);
    local(@datum,@value);    

    &getNumber;  
    &HTMLHeader;
    unless($FORM{'word'}) {
            print "<br><br><hr noshade width=80%>\n";
            print "<font color=blue>˻ Է ʾҽϴ</font>\n";
            print "<hr noshade width=80%>\n";
            print "<p><a href=$gCGI_URL?id=$FORM{'id'}&action=r&p=$FORM{'p'}><font color=$gTextColor>[Link ư]</font></a>\n";
    }
    else {
        open(HANDLE,"$gBaseDIR/$gDatFile");
            @datum = <HANDLE>;
        close(HANDLE);
          print "<table border=0 width=$gTableWidth cellpadding=0 cellspacing=1 align=center valign=top>\n";
          print "<tr><td width=220 align=left valign=top>";
     
          &MenuButton;
    
          print "</td>\n\n";   
          
          print "<td width=50>&nbsp;</td>\n\n<td align=left valign=top>\n<table border=0 width=100% cellspacing=1 cellpadding=0>\n";

# ũ ̸           
         print "<tr><td height=27\n";
         if ($FORM{'word'} eq "FastFind1") {
            print "&nbsp;<b>:: $gFastFind1 ::</b>\n";
         }
         if ($FORM{'word'} eq "FastFind2") {
            print "&nbsp;<b>:: $gFastFind2 ::</b>\n";
         }
         if ($FORM{'word'} eq "FastFind3") {
            print "&nbsp;<b>:: $gFastFind3 ::</b>\n";
         }
         if ($FORM{'word'} eq "FastFind4") {
            print "&nbsp;<b>:: $gFastFind4 ::</b>\n";
         }
         if ($FORM{'word'} eq "FastFind5") {
            print "&nbsp;<b>:: $gFastFind5 ::</b>\n";
         }
         print "</td></tr>\n";
              
        $counter = 0; 
        for($i=1;$i<=$gNoOfData;$i++ ) {
            @v = split(/\|/,$datum[$i]);            
            open(HANDLE,"$gBaseDIR/messages/$v[1].txt");
                $data = <HANDLE>;
            close(HANDLE);

            @value = split(/\|/,$data);
            if($value[9] =~ /$FORM{'word'}/i) {

                &printRecord;

                $counter++;
            }
         } 
         print "</td></tr></table></td></tr><tr><td colspan=3>\n";         
         print "</td></tr></table>\n";
    }
     print "<br><br><br><a href=$gCGI_URL?id=$FORM{'id'}&action=r&p=$FORM{'p'}><font color=$gTextColor>[ü Link ư]</font></a><br><br>\n";

        &HTMLFooter;  
}

sub printRecord {
    local($short_subject,$short_date,$actual_number,$old_date,$new_date);

$date_length = length($v[5]);

$short_date = substr($v[5],0,20);
         
print "<tr><td><table border=0 width=100% cellspacing=0 cellpadding=2>";
$c=$gTableBgcolor;
$t=$gTableText;
$tc=$gTableTapText;
$dc=$gTableTapBgcolor;
print "<tr bgcolor=$dc><td>&nbsp;::&nbsp;<b><a href=\"$v[8]\" target=_blank><font color=$tc>$v[2]</font></a></b></td>";
print "<td align=right><a href=$gCGI_URL?id=$FORM{'id'}&action=users_login&p=$FORM{'p'}&c=show_update_form&l=$v[1]><img src=$gIconURL/modify.gif border=0 alt=\"Modify\"></a><a href=$gCGI_URL?id=$FORM{'id'}&action=users_login&p=$FORM{'p'}&c=delete&l=$v[1]><img src=$gIconURL/del.gif border=0 alt=\"Delete\"></a>\n";
print "</td></tr>\n";
print "</table><table border=0 width=100% cellspacing=0 cellpadding=3>\n";

# ȭ  (̹ ũǾֳ  ...)
if ($v[9] eq "") {
print "<tr bgcolor=$c onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\"><td colspan=2 height=150 algin=left valign=top><font color=$t>$v[7]</font><br></td></tr>\n";
}

# ȭ 
else {
print "<tr bgcolor=$c onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
print "<td width=100% align=left valign=top><font color=$t>$v[7]</font><br></td>\n";
print "<td width=200 height=150 align=right valign=top><a href=\"$v[8]\" target=_blank><img src=\"$v[9]\" border=0></a></td>\n</tr>\n";
}

print "<tr><td colspan=2 width=100% height=1 bgcolor=\"$gTableintervalColor\"></td></tr>\n";
print "<tr><td colspan=2 width=100% height=2 bgcolor=\"$c\"></td></tr>\n";
print "<tr><td colspan=2 width=100% height=1 bgcolor=\"$gTableintervalColor\"></td></tr>\n";
print "<tr><td colspan=2>&nbsp;</td></tr>\n";
print "</table></tr>\n\n";
}

sub HTMLHeader {
    print "Content-type: text/html\n\n";
    print "<!---------------------------------------------------------------------------------->\n";
    print "<!--  Program Name  : Beomdori's Web Link v0.9                                   -->\n";
    print "<!--  Programer     : BeomGyu Lee                                                  -->\n";
    print "<!--  E-Mail        : cadeau\@orgio.net                                           -->\n";
    print "<!--  Homepage      : http://beomdori.x-y.net                                     -->\n";
    print "<!---------------------------------------------------------------------------------->\n\n";        
    print "<html>\n";
    print "<link rel=\"stylesheet\" type=\"text/css\" href=\"./bdr_link.css\">\n";
    print "<style>\n" ;
    print " BODY {background:url(\"$gBackImgURL\") ffffff fixed no-repeat 0% 98%}\n";
    print "-->\n";
    print "</style>\n" ;
    print "<script language=\"JavaScript\">\n";
    print "function nextWin()\n";
    print "{location = \"$gCGI_URL?id=$FORM{'id'}&action=r&p=$FORM{'p'}\"}\n";
    print "</script>\n";
    print "<script language=javascript>\n";
    print "function clearField(field){ if (field.value == field.defaultValue) {  field.value = ''; } }\n";
    print "function checkField(field){ if (field.value == '') { field.value = field.defaultValue; } }\n";
    print "</script>\n";

    if($gDelayTime == 0) {
        $gBackColor = "#ffffff" unless($gBackColor);
        print "<body bgcolor=$gBackColor topmargin=0 oncontextmenu='return false'>\n";
    }
    else {
        print "<meta http-equiv=refresh content=1;url=$gCGI_URL?id=$FORM{'id'}&action=r&p=$FORM{'p'}>\n";
        $gBackColor = "#ffffff" unless($gBackColor);
        print "<body bgcolor=$gBackColor topmargin=0 oncontextmenu='return false'><br>\n";
    }
    print "<center>\n";    
}

sub HTMLFooter {
    &copyright;
    print "</center>\n";
    print "</body>\n";
    print "</html>\n";
    exit;
}

sub copyright {
	print "<br><br><font color=\"#bbbbbb\">Copyright(c)2001<a href=\"http://beomdori.x-y.net\" target=\"_blank\"> <font color=\"#888888\">Beomdori</font></a> All Rights Reserved</font><br><br><br>\n";
}

#  ۾ 
sub showInputForm {
    local($data,$subject,$content,$subject2,$name,$value);
    local(@value,@cookies);
    
    # Űб 
    if($ENV{'HTTP_COOKIE'}) {
        @cookies = split(/; /,$ENV{'HTTP_COOKIE'});
        foreach(@cookies) {
            ($name,$value) = split(/=/,$_);
            $COOKIE{$name} = $value;
        }
    }
 
    &HTMLHeader;
    print "<form method=post action=$gCGI_URL>\n";    
    print "<br><br><table border=0 cellspacing=0 cellpadding=0>\n";
    print "<tr><td>\n";

    print "<table border=0 cellspacing=1 cellpadding=2>\n";    
    print "<input type=hidden name=id value=$FORM{'id'}>\n";
    print "<input type=hidden name=action value=write>\n";
    print "<input type=hidden name=p value=1>\n";

       if ($gFastFind eq "1") {
         print "<tr><td align=right>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td><select name=FastFinds style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=FastFind1 selected>$gFastFind1";
         print "</select>\n";
         print "</td></tr>\n";
       }

       if ($gFastFind eq "2") {
         print "<tr><td align=right>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td><select name=FastFinds style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=FastFind1 selected>$gFastFind1";
         print "<option value=FastFind2>$gFastFind2";
         print "</select>\n";
         print "</td></tr>\n";
       }

       if ($gFastFind eq "3") {
         print "<tr><td align=right>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td><select name=FastFinds style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=FastFind1 selected>$gFastFind1";
         print "<option value=FastFind2>$gFastFind2";
         print "<option value=FastFind3>$gFastFind3";
         print "</select>\n";
         print "</td></tr>\n";
        }
    
       if ($gFastFind eq "4") {
         print "<tr><td align=right>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td><select name=FastFinds style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=FastFind1 selected>$gFastFind1";
         print "<option value=FastFind2>$gFastFind2";
         print "<option value=FastFind3>$gFastFind3";
         print "<option value=FastFind4>$gFastFind4";
         print "</select>\n";
         print "</td></tr>\n";
       }

       if ($gFastFind eq "5") {
         print "<tr><td align=right>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td><select name=FastFinds style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=FastFind1 selected>$gFastFind1";
         print "<option value=FastFind2>$gFastFind2";
         print "<option value=FastFind3>$gFastFind3";
         print "<option value=FastFind4>$gFastFind4";
         print "<option value=FastFind5>$gFastFind5";
         print "</select>\n";
         print "</td></tr>\n";
       }
       
    print "<tr><td align=left>Password</td>\n";
    print "<td><input type=password name=passwd size=10 maxlength=10></td></tr>\n";
    print "<tr><td align=right>Ȩ&nbsp;</td><td>\n";
    print "<input name=homepage type=text value='' size=40>\n";
    print "</td></tr><tr><td align=right>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td>\n";
    print "<input name=subject value='' type=text size=40 value=''>\n";
    print "<input type=hidden name=html value=enable checked>\n";
    print "</tr><tr>\n";
    print "<td align=right valign=top>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td><textarea name=subject2 rows=8 cols=55></textarea></td>\n";
    print "</tr><tr><td align=right> URL</td><td>\n";
    print "<input name=banner value='' type=text size=54>\n";
    print "</td></tr><tr>\n";
    print "<td align=center colspan=2><input type=submit value=\" Ȯ  \"> <input type=reset value=\" Է \"></td>\n";
    print "</tr></table>\n";
    print "</td></tr></table>\n";
    print "</form>\n";
    print "<p><a href=$gCGI_URL?id=$FORM{'id'}&action=r&p=$FORM{'p'}><img src=\"$gIconURL/back.gif\" border=0></a>\n";
    &HTMLFooter;
}

#  ۾ 
sub showUserInputForm {
    local($data,$subject,$content,$subject2,$name,$value);
    local(@value,@cookies);
    
    # Űб 
    if($ENV{'HTTP_COOKIE'}) {
        @cookies = split(/; /,$ENV{'HTTP_COOKIE'});
        foreach(@cookies) {
            ($name,$value) = split(/=/,$_);
            $COOKIE{$name} = $value;
        }
    }
 
    &HTMLHeader;
    print "<form method=post action=$gCGI_URL>\n";    
    print "<br><br><table border=0 cellspacing=0 cellpadding=0>\n";
    print "<tr><td>\n";

    print "<table border=0 cellspacing=1 cellpadding=2>\n";    
    print "<input type=hidden name=id value=$FORM{'id'}>\n";
    print "<input type=hidden name=action value=write>\n";
    print "<input type=hidden name=p value=1>\n";
    
       if ($gFastFind eq "1") {
         print "<tr><td align=right>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td><select name=FastFinds style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=FastFind1 selected>$gFastFind1";
         print "<option value=FastFind2>$gFastFind2";
         print "</select>\n";
         print "</td></tr>\n";                   
       }

       if ($gFastFind eq "2") {
         print "<tr><td align=right>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td><select name=FastFinds style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=FastFind1 selected>$gFastFind1";
         print "<option value=FastFind2>$gFastFind2";
         print "</select>\n";
         print "</td></tr>\n";
       }

       if ($gFastFind eq "3") {
         print "<tr><td align=right>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td><select name=FastFinds style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=FastFind1 selected>$gFastFind1";
         print "<option value=FastFind2>$gFastFind2";
         print "<option value=FastFind3>$gFastFind3";
         print "</select>\n";
         print "</td></tr>\n";
        }
    
       if ($gFastFind eq "4") {
         print "<tr><td align=right>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td><select name=FastFinds style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=FastFind1 selected>$gFastFind1";
         print "<option value=FastFind2>$gFastFind2";
         print "<option value=FastFind3>$gFastFind3";
         print "<option value=FastFind4>$gFastFind4";
         print "</select>\n";
         print "</td></tr>\n";
       }

       if ($gFastFind eq "5") {
         print "<tr><td align=right>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td><select name=FastFinds style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=FastFind1 selected>$gFastFind1";
         print "<option value=FastFind2>$gFastFind2";
         print "<option value=FastFind3>$gFastFind3";
         print "<option value=FastFind4>$gFastFind4";
         print "<option value=FastFind5>$gFastFind5";
         print "</select>\n";
         print "</td></tr>\n";
       }
       
    print "<tr><td align=left>Password</td>\n";
    print "<td><input type=password name=passwd size=10 maxlength=10></td></tr>\n";
    print "<tr><td align=right>Ȩ&nbsp;</td><td>\n";
    print "<input name=homepage type=text value='' size=40>\n";
    print "</td></tr><tr><td align=right>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td>\n";
    print "<input name=subject value='' type=text size=40 value=''>\n";
    print "<input type=hidden name=html value=enable checked>\n";
    print "</tr><tr>\n";
    print "<td align=right valign=top>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td><textarea name=subject2 rows=8 cols=55></textarea></td>\n";
    print "</tr><tr><td align=right> URL</td><td>\n";
    print "<input name=banner value='' type=text size=54>\n";
    print "</td></tr><tr>\n";
    print "<td align=center colspan=2><input type=submit value=\" Ȯ  \"> <input type=reset value=\" Է \"></td>\n";
    print "</tr></table>\n";
    print "</td></tr></table>\n";
    print "</form>\n";
    print "<p><a href=$gCGI_URL?id=$FORM{'id'}&action=r&p=$FORM{'p'}><img src=\"$gIconURL/back.gif\" border=0></a>\n";
    &HTMLFooter;
}

sub writeData {
    &getNumber;
    &getVariable;

    &makeCryptPassword if($passwd);
    &makeNewFile;
    &appendIndexFile;
    &sendMail if($gAdminEmail);
    $gNoOfData++;
    &putNumber;

    print "Content-type: text/html\n\n";
    print "<!---------------------------------------------------------------------------------->\n";
    print "<!--  Program Name  : Beomdori's Web Link v0.9                                   -->\n";
    print "<!--  Programer     : BeomGyu Lee                                                  -->\n";
    print "<!--  E-Mail        : cadeau\@orgio.net                                           -->\n";
    print "<!--  Homepage      : http://beomdori.x-y.net                                     -->\n";
    print "<!---------------------------------------------------------------------------------->\n\n";        
    print "<html>\n";
    print "<link rel=\"stylesheet\" type=\"text/css\" href=\"./bdr_link.css\">\n";
    print "<style>\n" ;
    print " BODY {background:url(\"$gBackImgURL\") ffffff fixed no-repeat 0% 98%}\n";
    print "-->\n";
    print "</style>\n" ;    
    print "<script language=\"JavaScript\">\n";
    print "function nextWin()\n";
    print "{location = \"$gCGI_URL?id=$FORM{'id'}&action=r&p=$FORM{'p'}\"}\n";
    print "</script>\n";

    if($gDelayTime == 0) {
        $gBackColor = "#ffffff" unless($gBackColor);
        print "<body bgcolor=$gBackColor oncontextmenu='return false'>\n";
    }
    else {
        print "<meta http-equiv=refresh content=2;url=$gCGI_URL?id=$FORM{'id'}&action=r&p=$FORM{'p'}>\n";
        $gBackColor = "#ffffff" unless($gBackColor);
        print "<body bgcolor=$gBackColor oncontextmenu='return false'>\n";
    }

    print "<meta http-equiv=refresh content=\"0;  url=$gCGI_URL?id=$FORM{'id'}&action=r&p=$FORM{'p'}\">\n";

    print "</body></html>\n";
}

sub getVariable {
    if($FORM{'passwd'}) {
        $passwd = "$FORM{'passwd'}";
    }

    unless($FORM{'subject'} =~ /^\s*$/) {
      $subject = "$FORM{'subject'}";
      if($FORM{'subject'} eq '') {
        &error(no_subject);
      }
      else {
        $subject =~ s/</&lt;/g;
        $subject =~ s/>/&gt;/g;
        $subject =~ s/"/&quot;/g;
        $subject =~ s/\|/&#124;/g;
        $subject =~ s/\r\n\r\n/<p>/g;
        $subject =~ s/\r\n/<br>/g;
      }
    }
    else {
        &error(no_subject);
    }

    if($FORM{'subject2'}) {
        $subject2 = "$FORM{'subject2'}";
      if($FORM{'subject2'} eq '') {
        &error(no_subject2);
      }
      else {
        $subject2 =~ s/</&lt;/g;
        $subject2 =~ s/>/&gt;/g;
        $subject2 =~ s/"/&quot;/g;
        $subject2 =~ s/\|/&#124;/g;
        $subject2 =~ s/\r\n\r\n/<p>/g;
        $subject2 =~ s/\r\n/<br>/g;
      }
     }
     else {
        &error(no_subject2);
    }

    if($FORM{'homepage'}) {
      if($FORM{'homepage'} eq 'Ȩ') {
        &error(no_homepage);
      }
      else {
        $homepage = "$FORM{'homepage'}";
        $homepage =~ s/\|/&#124;/g;
      }
    }
    else {
        &error(no_homepage);
    }

    if($FORM{'banner'}) {
      if($FORM{'banner'} eq ' URL') {
        $banner = "";
      }
      else {
        $banner = "$FORM{'banner'}";
        $banner =~ s/\|/&#124;/g;
      }
    }
    else {
        $banner = "";
    }

    if($FORM{'FastFinds'}) {
        $FastFinds = "$FORM{'FastFinds'}";
      }
  
    &getDate;
}

sub getDate {     
    ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);

    if($sec < 10) {
        $sec = "0$sec";
    }
    if($min < 10) {
        $min = "0$min";
    }
    if($hour < 10) {
        $hour = "0$hour";
    }
    $mon++;
    if($mon < 10) {
        $mon = "0$mon";
    }
    if($mday < 10) {
        $mday = "0$mday";
    }

    $date = "$mon-$mday";
    $d = "$mon$mday";
}  

sub downData {
    &addHitCounter($FORM{'file'});

    print "Content-Type: application/octet-stream\n";
    print "Content-Disposition: attachment; filename=$FORM{'file'}\n\n";
    open(HANDLE,"<$gBaseDIR/files/$FORM{'file'}");
        binmode(HANDLE);
        binmode(STDOUT);
        binmode(STDERR);
        print <HANDLE>;
    close(HANDLE);
    exit;
}

sub makeCryptPassword  {
    local($crypt_code);
    local(@set);

    @set = ('a'..'z','A'..'Z','0'..'9','.','/');
    $crypt_code = "$set[9]$set[3]";
    $gCryptPassword = crypt($passwd,$crypt_code);
}

sub makeNewFile { 
    local(@set);

    @set = ('0'..'9'); 
    srand(time);
    $gRandomFilename = "$d$set[rand(10)]$set[rand(10)]$set[rand(10)]$set[rand(10)]";
    open(HANDLE,">$gBaseDIR/messages/$gRandomFilename.txt");
        print HANDLE "$gCryptPassword|$gRandomFilename|$name|$email|$date|$subject|$subject2|$homepage|$banner|$FastFinds|\n";
    close(HANDLE);
}

sub appendIndexFile {
    local($data);
    local(@datum,@point);

    &lock;
    open(HANDLE,"$gBaseDIR/$gDatFile");
        @datum = <HANDLE>;
    close(HANDLE);
    
    if($FORM{'l'}) {    # 亯 ߰ 
        open(HANDLE,">$gBaseDIR/$gDatFile");
        foreach $data (@datum) {
            @point = split(/\|/,$data);
            if($point[1] eq $FORM{'l'}) {
                $thread = $point[0] + 1;
                print HANDLE "$data";
	    print HANDLE "$thread|$gRandomFilename|$subject|$name|$email|$date|0|$subject2|$homepage|$banner|$FastFinds|\n";
            }
            else {
                print HANDLE "$data";
            }
        }
        close(HANDLE);
     }
     else {
        open(HANDLE,">$gBaseDIR/$gDatFile");
        foreach $data (@datum) {
            if($data =~ /<!--EOF-->/) {
                print HANDLE "<!--EOF-->\n";
	        print HANDLE "0|$gRandomFilename|$subject|$name|$email|$date|0|$subject2|$homepage|$banner|$FastFinds|\n";
            }
            else {
                print HANDLE "$data";
            }
        }
        close(HANDLE);
    }
    &unlock;
}

sub sendMail {
    open(MAIL,"|$gEmailPgm -t $mail");
    print MAIL "To: $email\n";
    print MAIL "From: $gAdminEmail\n";
    print MAIL "Subject: $gEmailSubject\n";
    $gEmailContent =~ s/<p>/\n\n/g;
    $gEmailContent =~ s/<br>/\n/g;
    print MAIL "$gEmailContent";
    close(MAIL);
}

sub error {
    local($error) = $_[0];
    
    &HTMLHeader;
    if($error eq "no_subject") {
        print "<br><br><hr noshade width=80%>\n";
        print "<font color=blue> ݵ ؾ մϴ</font><br>\n";
        print "<hr noshade width=80%><p>\n";
    }
    if($error eq "no_homepage") {
        print "<br><br><hr noshade width=80%>\n";
        print "<font color=blue>Ȩ ݵ ؾ մϴ</font><br>\n";
        print "<hr noshade width=80%><p>\n";
    }
    if($error eq "no_subject2") {
        print "<br><br><hr noshade width=80%>\n";
        print "<font color=blue> ݵ ؾ մϴ</font><br>\n";
        print "<hr noshade width=80%><p>\n";
    }
    else {
        print "<br><br><hr noshade width=80%>\n";
        print "<font color=blue>Գ ٽ Ȯϼ.</font><br>\n";
        print "<hr noshade width=80%><p>\n";
    }
    print "<p><a href=$gCGI_URL?id=$FORM{'id'}&action=r&p=$FORM{'p'}><font color=$gTextColor>[Link ư]</font></a>\n";
    &HTMLFooter;
}

sub showUsersLogin {
    local($command);

    if($FORM{'c'} eq "delete") {
        $command = "delete";
    }
    else {
        $command = "show_update_form";
    }
 
    &HTMLHeader;
    print "<form method=post action=$gCGI_URL>\n";
    print "<input type=hidden name=id value=$FORM{'id'}>\n"; 
    print "<input type=hidden name=p value=$FORM{'p'}>\n";
    print "<input type=hidden name=action value=$command>\n";
    print "<input type=hidden name=l value=$FORM{'l'}>\n";
    print "<br><br><b>Modify/Delete</b><br><br>\n";
    print "<font color=$gTextColor>йȣ </font>\n";
    print "<input type=password name=passwd size=10 maxlength=25> \n";
    print "<input type=submit value=\" Ȯ  \">\n" if($command eq "delete");
    print "<input type=submit value=\" Ȯ  \">\n" if($command eq "show_update_form");
    print "</form>\n";
    &HTMLFooter;       
}

sub checkUserPassword {
    local($data,$crypt_code,$save_password,$crypt_password);
    local(@passwd,@set,@datum,@value);
 
    open(HANDLE,"$gBaseDIR/messages/$FORM{'l'}.txt");
        $data = <HANDLE>;
    close(HANDLE);
    @passwd = split(/\|/,$data);

    open(HANDLE,"$gBaseDIR/$gPwdFile");
        $save_password = <HANDLE>;
    close(HANDLE);
    chop($save_password);

    @set = ('a'..'z','A'..'Z','0'..'9','.','/');
    $crypt_code = "$set[9]$set[3]";
    $crypt_password = crypt($FORM{'passwd'},$crypt_code);

    unless($crypt_password eq $passwd[0] || $crypt_password eq $save_password) {
        &HTMLHeader;
        print "<br><br><hr noshade width=80%>\n";
        print "<font color=$gTextColor> йȣ ġ ʽϴ.</font>\n";        
        print "<hr noshade width=80%>\n";
        print "</form><p><a href=$gCGI_URL?id=$FORM{'id'}&action=r&p=$FORM{'p'}><font color=$gTextColor>[Link ư]</font></a>\n";
        &HTMLFooter;
    } 
    
}

sub deleteData {
    local($delete_filename);
    local(@datum,@value);
 
    open(HANDLE,"$gBaseDIR/$gDatFile");
        @datum = <HANDLE>;
    close(HANDLE);
    open(HANDLE,">$gBaseDIR/$gDatFile");
    foreach $data (@datum) {
        @value = split(/\|/, $data);
        if($FORM{'l'} != $value[1]) {
            print HANDLE "$data";             
        }
        else {
            $delete_filename = $value[7];
        }
    }
    close(HANDLE);

    unlink("$gBaseDIR/messages/$FORM{'l'}.txt");
    unlink("$gBaseDIR/files/$delete_filename");
    &getNumber;
    $gNoOfData--;
    &putNumber;

    print "Content-type: text/html\n\n";
    print "<!---------------------------------------------------------------------------------->\n";
    print "<!--  Program Name  : Beomdori's Web Link v0.9                                   -->\n";
    print "<!--  Programer     : BeomGyu Lee                                                  -->\n";
    print "<!--  E-Mail        : cadeau\@orgio.net                                           -->\n";
    print "<!--  Homepage      : http://beomdori.x-y.net                                     -->\n";
    print "<!---------------------------------------------------------------------------------->\n\n";        
    print "<html>\n";
    print "<link rel=\"stylesheet\" type=\"text/css\" href=\"./bdr_link.css\">\n";
    print "<style>\n" ;
    print " BODY {background:url(\"$gBackImgURL\") ffffff fixed no-repeat 0% 98%}\n";
    print "-->\n";
    print "</style>\n" ;    
    print "<script language=\"JavaScript\">\n";
    print "function nextWin()\n";
    print "{location = \"$gCGI_URL?id=$FORM{'id'}&action=r&p=$FORM{'p'}\"}\n";
    print "</script>\n";

    if($gDelayTime == 0) {
       $gBackColor = "#ffffff" unless($gBackColor);
       print "<body bgcolor=$gBackColor oncontextmenu='return false'>\n";
    }
    else {
        print "<meta http-equiv=refresh content=2;url=$gCGI_URL?id=$FORM{'id'}&action=r&p=$FORM{'p'}>\n";
        $gBackColor = "#ffffff" unless($gBackColor);
        print "<body bgcolor=$gBackColor oncontextmenu='return false'>\n";
    }

    print "<meta http-equiv=refresh content=\"0;  url=$gCGI_URL?id=$FORM{'id'}&action=r&p=$FORM{'p'}\">\n";

    print "</body></html>\n";
}

sub showUpdateForm {
    local($data,$name,$value);
    local(@cookies);
    
    # Ű б
    local(@value);
    if($ENV{'HTTP_COOKIE'}) {
        @cookies = split(/; /,$ENV{'HTTP_COOKIE'});
        foreach(@cookies) {
            ($name,$value) = split(/=/,$_);
            $COOKIE{$name} = $value;
        }
    }
 
    open(HANDLE,"$gBaseDIR/messages/$FORM{'l'}.txt");
        $data = <HANDLE>;
    close(HANDLE);
    @value = split(/\|/,$data);             

    &HTMLHeader;
    print "<form method=post action=$gCGI_URL>\n";
    print "<input type=hidden name=id value=$FORM{'id'}>\n"; 
    print "<input type=hidden name=action value=update>\n";
    print "<input type=hidden name=p value=$FORM{'p'}>\n";
    print "<input type=hidden name=l value=$FORM{'l'}>\n";
    print "<input type=hidden name=OldPassword value=$value[0]>\n";
    print "<br><br><table border=0 cellspacing=0 cellpadding=0>\n";
    print "<tr><td>\n";

    print "<table border=0 cellspacing=1 cellpadding=2>\n";    
    print "<tr><td>\n";
              
    if ($gFastFind eq "2") {
      if($value[9] eq "") {    	    	
         print "<tr><td align=right>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td><select name=FastFinds style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=FastFind1 selected>$gFastFind1";
         print "<option value=FastFind2>$gFastFind2";
         print "</select>\n";
         print "</td></tr>\n";
      }         
      if($value[9] eq "FastFind1") {    	    	
         print "<tr><td align=right>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td><select name=FastFinds style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=FastFind1 selected>$gFastFind1";
         print "<option value=FastFind2>$gFastFind2";
         print "</select>\n";
         print "</td></tr>\n";
      }
      if($value[9] eq "FastFind2") {    	    	
         print "<tr><td align=right>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td><select name=FastFinds style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=FastFind1>$gFastFind1";
         print "<option value=FastFind2 selected>$gFastFind2";
         print "</select>\n";
         print "</td></tr>\n";
      }            
    }
     
    if ($gFastFind eq "3") {
      if($value[9] eq "") {    	    	
         print "<tr><td align=right>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td><select name=FastFinds style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=FastFind1 selected>$gFastFind1";
         print "<option value=FastFind2>$gFastFind2";
         print "<option value=FastFind3>$gFastFind3";         
         print "</select>\n";
         print "</td></tr>\n";
      }         
      if($value[9] eq "FastFind1") {    	    	
         print "<tr><td align=right>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td><select name=FastFinds style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=FastFind1 selected>$gFastFind1";
         print "<option value=FastFind2>$gFastFind2";
         print "<option value=FastFind3>$gFastFind3";                  
         print "</select>\n";
         print "</td></tr>\n";
      }
      if($value[9] eq "FastFind2") {    	    	
         print "<tr><td align=right>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td><select name=FastFinds style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=FastFind1>$gFastFind1";
         print "<option value=FastFind2 selected>$gFastFind2";
         print "<option value=FastFind3>$gFastFind3";                  
         print "</select>\n";
         print "</td></tr>\n";
      }            
      if($value[9] eq "FastFind3") {    	    	
         print "<tr><td align=right>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td><select name=FastFinds style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=FastFind1>$gFastFind1";
         print "<option value=FastFind2>$gFastFind2";
         print "<option value=FastFind3 selected>$gFastFind3";         
         print "</select>\n";
         print "</td></tr>\n";
      }                  
    }
    
    if ($gFastFind eq "4") {
      if($value[9] eq "") {    	    	
         print "<tr><td align=right>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td><select name=FastFinds style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=FastFind1 selected>$gFastFind1";
         print "<option value=FastFind2>$gFastFind2";
         print "<option value=FastFind3>$gFastFind3";         
         print "<option value=FastFind4>$gFastFind4";                  
         print "</select>\n";
         print "</td></tr>\n";
      }         
      if($value[9] eq "FastFind1") {    	    	
         print "<tr><td align=right>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td><select name=FastFinds style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=FastFind1 selected>$gFastFind1";
         print "<option value=FastFind2>$gFastFind2";
         print "<option value=FastFind3>$gFastFind3";         
         print "<option value=FastFind4>$gFastFind4";                           
         print "</select>\n";
         print "</td></tr>\n";
      }
      if($value[9] eq "FastFind2") {    	    	
         print "<tr><td align=right>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td><select name=FastFinds style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=FastFind1>$gFastFind1";
         print "<option value=FastFind2 selected>$gFastFind2";
         print "<option value=FastFind3>$gFastFind3";         
         print "<option value=FastFind4>$gFastFind4";                  
         print "</select>\n";
         print "</td></tr>\n";
      }            
      if($value[9] eq "FastFind3") {    	    	
         print "<tr><td align=right>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td><select name=FastFinds style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=FastFind1>$gFastFind1";
         print "<option value=FastFind2>$gFastFind2";
         print "<option value=FastFind3 selected>$gFastFind3";         
         print "<option value=FastFind4>$gFastFind4";                  
         print "</select>\n";
         print "</td></tr>\n";
      }                  
      if($value[9] eq "FastFind4") {    	    	
         print "<tr><td align=right>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td><select name=FastFinds style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=FastFind1>$gFastFind1";
         print "<option value=FastFind2>$gFastFind2";
         print "<option value=FastFind3>$gFastFind3";         
         print "<option value=FastFind4 selected>$gFastFind4";                  
         print "</select>\n";
         print "</td></tr>\n";
      }                       
    }
         
    if ($gFastFind eq "5") {
      if($value[9] eq "") {    	    	
         print "<tr><td align=right>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td><select name=FastFinds style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=FastFind1 selected>$gFastFind1";
         print "<option value=FastFind2>$gFastFind2";
         print "<option value=FastFind3>$gFastFind3";         
         print "<option value=FastFind4>$gFastFind4";         
         print "<option value=FastFind5>$gFastFind5";                                    
         print "</select>\n";
         print "</td></tr>\n";
      }         
      if($value[9] eq "FastFind1") {    	    	
         print "<tr><td align=right>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td><select name=FastFinds style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=FastFind1 selected>$gFastFind1";
         print "<option value=FastFind2>$gFastFind2";
         print "<option value=FastFind3>$gFastFind3";         
         print "<option value=FastFind4>$gFastFind4";         
         print "<option value=FastFind5>$gFastFind5";                                    
         print "</select>\n";
         print "</td></tr>\n";
      }
      if($value[9] eq "FastFind2") {    	    	
         print "<tr><td align=right>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td><select name=FastFinds style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=FastFind1>$gFastFind1";
         print "<option value=FastFind2 selected>$gFastFind2";
         print "<option value=FastFind3>$gFastFind3";                  
         print "<option value=FastFind4>$gFastFind4";         
         print "<option value=FastFind5>$gFastFind5";                           
         print "</select>\n";
         print "</td></tr>\n";
      }            
      if($value[9] eq "FastFind3") {    	    	
         print "<tr><td align=right>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td><select name=FastFinds style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=FastFind1>$gFastFind1";
         print "<option value=FastFind2>$gFastFind2";
         print "<option value=FastFind3 selected>$gFastFind3";         
         print "<option value=FastFind4>$gFastFind4";         
         print "<option value=FastFind5>$gFastFind5";                           
         print "</select>\n";
         print "</td></tr>\n";
      }                  
      if($value[9] eq "FastFind4") {    	    	
         print "<tr><td align=right>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td><select name=FastFinds style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=FastFind1>$gFastFind1";
         print "<option value=FastFind2>$gFastFind2";
         print "<option value=FastFind3>$gFastFind3";         
         print "<option value=FastFind4 selected>$gFastFind4";                                    
         print "<option value=FastFind5>$gFastFind5";                  
         print "</select>\n";
         print "</td></tr>\n";
      }                       
      if($value[9] eq "FastFind5") {    	    	
         print "<tr><td align=right>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td><select name=FastFinds style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=FastFind1>$gFastFind1";
         print "<option value=FastFind2>$gFastFind2";
         print "<option value=FastFind3>$gFastFind3";         
         print "<option value=FastFind4>$gFastFind4";                  
         print "<option value=FastFind5 selected>$gFastFind5";                                             
         print "</select>\n";
         print "</td></tr>\n";
      }                             
    }

    print "<tr><td align=right>Ȩ&nbsp;</td><td>\n";
    print "<input name=homepage type=text value=\"$value[7]\" size=40 type=text>\n";

    print "</td></tr><tr><td align=right>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td>\n";
    $value[5] =~ s/<br>/\n/g;
    $value[5] =~ s/<p>/\n\n/g;
    print "<input name=subject value=\"$value[5]\" type=text size=40 value=''>\n";
    print "<input type=hidden name=html value=enable checked>\n";
    print "</tr><tr>\n";
    $value[6] =~ s/<br>/\n/g;
    $value[6] =~ s/<p>/\n\n/g;
    print "<td align=right valign=top>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td><td><textarea name=subject2 rows=8 cols=55>$value[6]</textarea></td>\n";    
    print "</tr><tr><td align=right> URL</td><td>\n";
    print "<input name=banner value=\"$value[8]\" type=text size=54>\n";
    print "</td></tr><tr>\n";
    print "<td align=center colspan=2><input type=submit value=\" Ȯ  \"> <input type=reset value=\" Է \"></td>\n";
    print "</tr></table>\n";
    print "</td></tr></table>\n";
    print "</form>\n";
    print "<p><a href=$gCGI_URL?id=$FORM{'id'}&action=r&p=$FORM{'p'}><img src=\"$gIconURL/back.gif\" border=0></a>\n";
    &HTMLFooter;       
}

sub updateData {
    local(@datum,@value);

    &getVariable;
    open(HANDLE,"<$gBaseDIR/$gDatFile");
        @datum = <HANDLE>;
    close(HANDLE);

    open(HANDLE,">$gBaseDIR/$gDatFile");
    foreach $data (@datum) {
        @value = split(/\|/,$data);
        if($FORM{'l'} eq $value[1]) {
            print HANDLE "$value[0]|$FORM{'l'}|$subject|$name|$email|$value[5]|$value[6]|$subject2|$homepage|$banner|$FastFinds|\n";
        }
        else {
            print HANDLE "$data";
        }
    }
    close(HANDLE);
    open(HANDLE,">$gBaseDIR/messages/$FORM{'l'}.txt");
        print HANDLE "$FORM{'OldPassword'}|$FORM{'l'}|$name|$email|$value[5]|$subject|$subject2|$homepage|$banner|$FastFinds|\n";
    close(HANDLE);

    print "Content-type: text/html\n\n";
    print "<!---------------------------------------------------------------------------------->\n";
    print "<!--  Program Name  : Beomdori's Web Link v0.9                                   -->\n";
    print "<!--  Programer     : BeomGyu Lee                                                  -->\n";
    print "<!--  E-Mail        : cadeau\@orgio.net                                           -->\n";
    print "<!--  Homepage      : http://beomdori.x-y.net                                     -->\n";
    print "<!---------------------------------------------------------------------------------->\n\n";
    print "<html>\n";
    print "<link rel=\"stylesheet\" type=\"text/css\" href=\"./bdr_link.css\">\n";
    print "<style>\n" ;
    print " BODY {background:url(\"$gBackImgURL\") ffffff fixed no-repeat 0% 98%}\n";
    print "-->\n";
    print "</style>\n" ;    
    print "<script language=\"JavaScript\">\n";
    print "function nextWin()\n";
    print "{location = \"$gCGI_URL?id=$FORM{'id'}&action=r&p=$FORM{'p'}\"}\n";
    print "</script>\n";

    if($gDelayTime == 0) {
       $gBackColor = "#ffffff" unless($gBackColor);
       print "<body bgcolor=$gBackColor oncontextmenu='return false'>\n";
    }
    else {
        print "<meta http-equiv=refresh content=2;url=$gCGI_URL?id=$FORM{'id'}&action=r&p=$FORM{'p'}>\n";
        $gBackColor = "#ffffff" unless($gBackColor);
        print "<body bgcolor=$gBackColor oncontextmenu='return false'>\n";
    }

    print "<meta http-equiv=refresh content=\"0;  url=$gCGI_URL?id=$FORM{'id'}&action=r&p=$FORM{'p'}\">\n";

    print "</body></html>\n";
}

sub showAdminLogin {
    &HTMLHeader;
    unless(open(HANDLE,"$gBaseDIR/$gPwdFile")) {
        print "<br><br><form action=$gCGI_URL>\n";
        print "<input type=hidden name=id value=$FORM{'id'}>\n";    
        print "<input type=hidden name=action value=$FORM{'c'}>\n";
        print "<input type=hidden name=p value=$FORM{'p'}>\n";
        print "<input type=hidden name=ps value=new>\n";
        print "<b> йȣ </b><br><br>\n";
        print "<table border=0 width=150>\n";
        print "<tr><td width=50 align=left>йȣ</td><td align=left><input type=password name=newpasswd size=10 maxlength=20></td></tr>\n";
        print "<tr><td width=50 align=left>  </td><td align=left><input type=password name=repasswd size=10 maxlength=20></td></tr>\n";
        print "<tr><td width=50></td><td align=left><input type=submit value=\" Ȯ \"></td></tr>\n";
        print "</table>\n";
        print "</font></form>\n";
    }
    else {
        print "<br><br><form method=post action=$gCGI_URL>\n";
        print "<input type=hidden name=id value=$FORM{'id'}>\n"; 
        print "<input type=hidden name=action value=$FORM{'c'}>\n";
        print "<input type=hidden name=p value=$FORM{'p'}>\n";
        print "<input type=hidden name=ps value=old>\n";
        print "<b>Config/Write</b><br><br>\n";      
        print "<input type=radio name=action value=$FORM{'c'} checked style=\"background-color:#ffffff;border:1 solid white\"> ȯ漳 &nbsp; &nbsp;\n";
        print "<input type=radio name=action value=show_input_form style=\"background-color:#ffffff;border:1 solid white\"> ۾\n";
        print "<br><br>йȣ&nbsp;<input type=password name=oldpasswd size=10 maxlength=20>\n";
        print " <input type=submit value=\" Ȯ \">\n";
        print "</form>\n";
    }
    &HTMLFooter;
    close(HANDLE);
}
 
sub checkAdminPassword {
    local($crypt_code,$save_password,$old_password,$new_password);
    local(@set);
    
    # йȣ űԷ
    if($FORM{'ps'} eq "new") {  
        if($FORM{'newpasswd'} eq $FORM{'repasswd'}) {
            if($FORM{'newpasswd'} ne "") {
                @set = ('a'..'z','A'..'Z','0'..'9','.','/');
                $crypt_code = "$set[9]$set[3]";
                $save_password = crypt($FORM{'newpasswd'},$crypt_code);
                open(HANDLE,">$gBaseDIR/$gPwdFile");
                    print HANDLE "$save_password\n";
	                close(HANDLE);
            }
            else {
                &HTMLHeader;
                print "<br><br><hr noshade width=80%>\n";
                print "<font color=blue> йȣ Է ʾҽϴ</font>\n";
                print "<hr noshade width=80%>\n";
                print "</form><p><a href=$gCGI_URL?id=$FORM{'id'}&action=r&p=$FORM{'p'}><font color=$gTextColor>[Link ư]</font></a>\n";

                &HTMLFooter;
            }
        }
        else {
            &HTMLHeader;
            print "<br><br><hr noshade width=80%>\n";
            print "<font color=blue> йȣ ġ ʽϴ</font>\n";
            print "<hr noshade width=80%>\n";
            print "</form><p><a href=$gCGI_URL?id=$FORM{'id'}&action=r&p=$FORM{'p'}><font color=$gTextColor>[Link ư]</font></a>\n";
            &HTMLFooter;
        } 
    } 

    # йȣ Ȯ
    else { 
        open(HANDLE,"<$gBaseDIR/$gPwdFile");
            $save_password = <HANDLE>;
        close(HANDLE);
        chop($save_password);

        @set = ('a'..'z','A'..'Z','0'..'9','.','/');
        $crypt_code = "$set[9]$set[3]";
        $old_password = crypt($FORM{'oldpasswd'},$crypt_code);

        unless($old_password eq $save_password) {
            &HTMLHeader;
            print "<br><br><hr noshade width=80%>\n";
            print "<font color=blue> йȣ ġ ʽϴ</font>\n";
            print "<hr noshade width=80%>\n";
            print "</form><p><a href=$gCGI_URL?id=$FORM{'id'}&action=r&p=$FORM{'p'}><font color=$gTextColor>[Link ư]</font></a>\n";
            &HTMLFooter;
        }
    }
}

sub checkConfigPassword {
    local($crypt_code,$save_password,$old_password,$new_password,$cur_passwd);
    local(@set);
 
        open(HANDLE,"<$gBaseDIR/$gPwdFile");
            $save_password = <HANDLE>;
        close(HANDLE);
        chop($save_password);

        @set = ('a'..'z','A'..'Z','0'..'9','.','/');
        $crypt_code = "$set[9]$set[3]";
        $old_password = crypt($FORM{'oldpasswd'},$crypt_code);

        unless($old_password eq $save_password) {
            &HTMLHeader;
	        print "<br>| <a href=\"javascript:history.back()\">ڷ</a> |\n";
            print "<br><br><hr noshade width=80%>\n";
            print "<font color=blue>ȯ漳 Ȯ   йȣ ġ ʽϴ.</font>\n";
            print "<hr noshade width=80%>\n";
            &HTMLFooter;
        }
}

#  ȯ漳 

sub showConfigForm {
    &HTMLHeader;
    print "<br><br><b><font color=\"3355cc\">Beomdori's Web Link Config</font></b><br><br>\n";
    print "<table border=0 width=500><tr><td>\n";
    print "<form action=$gCGI_URL>\n";
    print "<input type=hidden name=id value=$FORM{'id'}>\n";
    print "<input type=hidden name=action value=config>\n";
    print "<input type=hidden name=p value=$FORM{'p'}>\n";
    print "<input type=hidden name=ps value=new>\n";

# DB 
    print "<table border=0 width=100% cellpadding=2 cellspacing=1 onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
    print "<tr align=left><td colspan=2><b> :: DB :: </b></td></tr>\n";

    if($gMakeBoard eq "Y") {
        $gMakeBoard = "";
    } 
    else {
        $gMakeBoard = "";
    }
    print "<tr><td align=left>DB ߰ </td><td align=right><font color=red><b>$gMakeBoard</b></font>\n";
    print "</td></tr></table><br>\n";

# йȣ     
    print "<table border=0 width=100% cellpadding=2 cellspacing=1 onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
    print "<tr align=left><td colspan=2><b> :: йȣ  :: </b></td></tr>\n";
    print "<tr align=right><td colspan=2> йȣ <input type=password name=newpasswd size=10 maxlength=8>\n";
    print "<tr align=right><td colspan=2>   <input type=password name=repasswd size=10 maxlength=8>\n";
    print "</td></tr></table><br>\n";

######
    print "<table border=0 width=100% cellpadding=2 cellspacing=1 onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
    print "<tr align=left><td colspan=2><b> ::  :: </b></td></tr>\n";
    print "<tr><td align=left>Background Color</td><td align=right><input type=text name=BackColor value=\"$gBackColor\" size=10></td></tr>\n";
    print "<tr><td align=left>Text Color</td><td align=right><input type=text name=TextColor value=\"$gTextColor\" size=10></td></tr>\n";
    print "<tr><td align=left>Background URL</td><td align=right><input type=text name=BackImgURL value=\"$gBackImgURL\" size=40></td></tr>\n";
    print "</table><br>\n";

###ŸƲ###
    print "<table border=0 width=100% cellpadding=2 cellspacing=1 onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
    print "<tr align=left><td colspan=2><b>:: Title ::</td></tr>\n";
    print "<tr><td align=left>Title ̱</td><td align=right><select name=TitleUse></font>";
    if($gTitleUse eq "YES") {
        print "<option value=YES selected>";
        print "<option value=NO>Ұ";
    }
    else {
        print "<option value=YES>";
        print "<option value=NO selected>Ұ";
    }
    print "</select></td></tr>\n";
    print "<tr><td align=left>ŸƲ Text</td><td align=right><input type=text name=TitleText value=\"$gTitleText\" size=40 maxlength=7 class=ad></td></tr>\n";        
    print "</table><br>\n";

### ###
    print "<table border=0 width=100% cellpadding=2 cellspacing=1 onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
    print "<tr align=left><td colspan=2><b> ::   :: </b></td></tr>\n";

    print "<tr><td align=left>̺  Bgcolor</td><td align=right><input type=text name=TitleBack value=\"$gTableTapBgcolor\" size=10></td></tr>\n";
    print "<tr><td align=left>̺  Text</td><td align=right><input type=text name=TitleColor value=\"$gTableTapText\" size=10></td></tr>\n";    
    
    print "<tr><td align=left>̺ Bgcolor</td><td align=right><input type=text name=TableBgcolor value=\"$gTableBgcolor\" size=10></td></tr>\n";
    print "<tr><td align=left>̺ Text</td><td align=right><input type=text name=TableText value=\"$gTableText\" size=10></td></tr>\n";    
    print "<tr><td align=left>Ȱȭ ̺ Color</td><td align=right><input type=text name=ActiveTableColor value=\"$gActiveTableColor\" size=10></td></tr>\n";
    print "<tr><td align=left>̺  Color</td><td align=right><input type=text name=TableintervalColor value=\"$gTableintervalColor\" size=10></td></tr>\n";    
    print "</table><br>\n";

###Display ###
    print "<table border=0 width=100% cellpadding=2 cellspacing=1 onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
    print "<tr align=left><td colspan=2><b> :: Display  :: </b></td></tr>\n";
    print "<tr><td align=left> </td><td align=right><select name=UserUp></font>";
    if($gUserUp eq "YES") {
        print "<option value=YES selected>";
        print "<option value=NO>Ұ";
    }
    else {
        print "<option value=YES>";
        print "<option value=NO selected>Ұ";
    }
    print "</select></td></tr>\n";    
    print "<tr><td align=left>Table Size</td><td align=right><input type=text name=TableWidth value=\"$gTableWidth\" size=10>\n";
    print "<tr><td align=left>ǥ </td><td align=right><input type=text name=RecPerPage value=\"$gRecPerPage\" size=10>\n";
    print "<tr><td align=left>Ʈ  </td><td align=right><input type=text name=ListNumber value=\"$gListNumber\" size=10>\n";
    print "</table><br>\n";

###ٷΰ з ###
    print "<table border=0 width=100% cellpadding=2 cellspacing=1 onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
    print "<tr align=left><td colspan=2><b> :: з  :: </b></td></tr>\n";
    print "<tr><td align=left>з  (0 ̸ ǥþ)</td><td align=right><input type=text name=FastFind value=\"$gFastFind\" size=10>\n";
    print "<tr><td align=left>з ׸ 1</td><td align=right><input type=text name=FastFind1 value=\"$gFastFind1\" size=10>\n";
    print "<tr><td align=left>з ׸ 2</td><td align=right><input type=text name=FastFind2 value=\"$gFastFind2\" size=10>\n";
    print "<tr><td align=left>з ׸ 3</td><td align=right><input type=text name=FastFind3 value=\"$gFastFind3\" size=10>\n";
    print "<tr><td align=left>з ׸ 4</td><td align=right><input type=text name=FastFind4 value=\"$gFastFind4\" size=10>\n";
    print "<tr><td align=left>з ׸ 5</td><td align=right><input type=text name=FastFind5 value=\"$gFastFind5\" size=10>\n";
    print "</td></tr></table><br>\n";

    print "<p align=center>\n";
    print "<input type=submit value=\" Ȯ  \">\n";
    print "</form>\n";
    print "</tr></td></table>\n";

    &HTMLFooter;
}

sub updateEnvVar {
    &checkAdminPassword if($FORM{'newpasswd'} || $FORM{'repassword'});

    $gBackColor = $FORM{'BackColor'};
    $gTextColor = $FORM{'TextColor'};
    $gBackImgURL = $FORM{'BackImgURL'};
    $gTitleText = $FORM{'TitleText'};
    $gTempURL2 = $FORM{'TempURL2'} if($FORM{'TempURL2'} =~ /^http:\/\// || $FORM{'TempURL2'} eq "");
    $gTempColor1 = $FORM{'TempColor1'};
    $gTempColor2 = $FORM{'TempColor2'};
    $gTableintervalColor = $FORM{'TableintervalColor'};

    $gTableText = $FORM{'TableText'};

    $gTableWidth = $FORM{'TableWidth'};         
    $gRecPerPage = $FORM{'RecPerPage'} if($FORM{'RecPerPage'} >= 1);

    $gListNumber = $FORM{'ListNumber'};
    $gTempColor4 = $FORM{'TempColor4'};

    $gTableTapText = $FORM{'TitleColor'};

    $gActiveTableColor = $FORM{'ActiveTableColor'};

    $gTempYesOrNo1 = $FORM{'TagUse'};

    $gTitleUse = $FORM{'TitleUse'};
    $gTempNum2 = $FORM{'TempNum2'};
    $gTempColor3 = $FORM{'TempColor3'};
    $gTempNum1 = $FORM{'TopMargin'};

    $gTableBgcolor = $FORM{'TableBgcolor'};
    $gTempcolor1 = $FORM{'TempColor1'};
    $gTempcolor2 = $FORM{'TempColor2'};

    $gTempYesOrNo2 = $FORM{'TempYesOrNo2'};
    $gTempYesOrNo3 = $FORM{'TempYesOrNo3'};

    $gTempURL1 = $FORM{'TableImage'};

    $gTableTapBgcolor = $FORM{'TitleBack'};

    $gFastFind = $FORM{'FastFind'};
    $gFastFind1 = $FORM{'FastFind1'};
    $gFastFind2 = $FORM{'FastFind2'};
    $gFastFind3 = $FORM{'FastFind3'};
    $gFastFind4 = $FORM{'FastFind4'};
    $gFastFind5 = $FORM{'FastFind5'};

    $gUserUp = $FORM{'UserUp'};

    $gTempYesOrNo4 = $FORM{'TempYesOrNo4'};
    $gTempYesOrNo5 = $FORM{'TempYesOrNo5'};
    
    &putEnvVar;
    $gCurPage = $FORM{'p'};
    &readData;
}

sub lock {
    local($LockFile) = "$gBaseDIR/lock.txt";
    local($EndTime) = time+45;

    while(-e $LockFile && time < $EndTime) {}
    open(LOCK,">$LockFile");
    chmod 0666,$LockFile;

    if($gLockFlag eq 'Y') {
        flock(LOCK,2);
    }
    $gLockStat = 'Y';
}    

sub unlock {
    local($LockFile) = "$gBaseDIR/lock.txt";

    if($gLockStat eq 'Y') {
        if($gLockFlag eq 'Y') {
            flock(LOCK,8); 
        }
        close(LOCK);
        if(-e $LockFile) { 
            unlink($LockFile);
        }
        $gLockStat = 'N'; 
    }
}